"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertFunctionTypeAnnotation = void 0;
const t = __importStar(require("@babel/types"));
const convertTSType_1 = require("./convertTSType");
const convertTSTypeParameterDeclaration_1 = require("./convertTSTypeParameterDeclaration");
const baseNodeProps_1 = require("../utils/baseNodeProps");
function convertFunctionTypeAnnotation(node) {
    let typeParams = undefined;
    if (node.typeParameters && !t.isNoop(node.typeParameters)) {
        typeParams = Object.assign(Object.assign({}, (0, convertTSTypeParameterDeclaration_1.convertTSTypeParameterDeclaration)(node.typeParameters)), (0, baseNodeProps_1.baseNodeProps)(node.typeParameters));
    }
    const parameters = [];
    let returnType = null;
    if (t.isTSDeclareFunction(node) || t.isTSDeclareMethod(node)) {
        returnType =
            node.returnType && !t.isNoop(node.returnType)
                ? (0, convertTSType_1.convertTSType)(node.returnType.typeAnnotation)
                : null;
    }
    else {
        returnType = node.typeAnnotation
            ? (0, convertTSType_1.convertTSType)(node.typeAnnotation.typeAnnotation)
            : null;
    }
    let rest = null;
    const originalParams = t.isTSDeclareFunction(node) || t.isTSDeclareMethod(node)
        ? node.params
        : node.parameters;
    const isDeclaration = t.isTSDeclareFunction(node) || t.isTSDeclareMethod(node);
    let variableNumber = 0;
    for (const param of originalParams) {
        if (t.isIdentifier(param)) {
            if (param.name !== 'this') {
                parameters.push(Object.assign(Object.assign({}, t.functionTypeParam(t.identifier(param.name), (0, convertTSType_1.convertTSType)(param.typeAnnotation.typeAnnotation))), { optional: param.optional }));
            }
        }
        else if (t.isRestElement(param)) {
            rest = t.functionTypeParam(
            // @ts-ignore todo:
            param.argument, (0, convertTSType_1.convertTSType)(param.typeAnnotation.typeAnnotation));
        }
        else {
            // todo: sepearate declarations from implementations
            if (isDeclaration) {
                // @ts-ignore
                parameters.push(t.functionTypeParam(t.identifier(`v${variableNumber}`), 
                // @ts-ignore
                param.typeAnnotation
                    ? (0, convertTSType_1.convertTSType)(
                    // @ts-ignore
                    param.typeAnnotation.typeAnnotation)
                    : t.anyTypeAnnotation()));
                variableNumber += 1;
            }
            else {
                throw new Error('todo:');
            }
        }
    }
    return { typeParams, parameters, rest, returnType };
}
exports.convertFunctionTypeAnnotation = convertFunctionTypeAnnotation;
//# sourceMappingURL=convertFunctionTypeAnnotation.js.map